//
// C++ Interface: common
//
// Description: common declarations
//
//
// Author: RealQuick <RealQuick@doubleQuick.de>, (C) 2009
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef __COMMON_H
#define __COMMON_H

#define WAIT_DEL_TIME 5  // Wait spcified amount of time before removing wrong EPG data

#define WAIT_AFTER_STARTUP 600	// Time to wait for automatic import after system startup
#define IMPORT_MANUALLY 0
#define IMPORT_AFTER_STARTUP 1

#define MAX_PROVIDER_CHANNEL 1
#define PROVIDER_HASHSIZE 6000
#define COLLISION_TABSIZE 1000

#define MAX_VDR_CHANNELS 10000

#define NOEPG_OFF 			0
#define NOEPG_HOUSEKEEPING 		1
#define NOEPG_CHANNELSWITCH 		2
#define NOEPG_CHANNELSWITCH_HOUSEKEEPING 3
#define NOEPG_PATCHED_VDR 		4

#define USERAGENTSTRING "iepg iepg@mail.inder.nett"

//#define URLLISTFILENAME "/home/reel/tmp/url.list"
#define URLLISTFILENAME "url.list"
//list of urls and channel name
//TODO put it in a place where it is not periodically deleted
// eg. /var/config ?

/*
 * format of url.list
 *
 * CHANNEL NAME1; URL1
 * CHANNEL NAME2; URL2
 */

#define LINEFEED "\n"

#define DELETENULL(p) (delete (p), p = NULL)

#define HDOSD_MAX_IMAGES 333

#define IEPG_PATH "/media/tmp/iepg"
#define IMAGE_PATH "/media/tmp/iepg/images"

#define CHANNELS_ALL_CONF "channels_all.conf"

#define LOGFILE_IMPORT "import.log"
#define LOGFILE_THREAD "thread.log"
#define LOGFILE_STATUS "status.log"

#define MAX_EPG_DELTA_SECONDS 600	// Check for move of event start time for MAX_EPG_DELTA_SECONDS

// For updating bgprocess progrss bars
#define MAIN_PROG 0
#define PIC_UPDATE 1
#define EPG_UPDATE 2

#define EPG_DOWNLOAD 0
#define EPG_LOAD 1
#define EPG_UPDATE 2 

#define OSDHEIGHT                 576                     // in pixels
#define OSDWIDTH                  720                     // in pixels


#define PNG_MAX_WIDTH_EHD 250 // max width for DrawImage send to OSD (EHD)
#define PNG_MAX_HEIGHT_EHD 110 // max height for DrawImage send to OSD (EHD)

#define PNG_MAX_WIDTH_BSP 30 // max width for DrawImage send to OSD (BSP)
#define PNG_MAX_HEIGHT_BSP 30 // max height for DrawImage send to OSD (BSP

#endif

