//
// C++ Interface: iepg.h
//
// Description: 
//
//
// Author: RealQuick <RealQuick@doubleQuick.de>, (C) 2009
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef __IEPG_H
#define __IEPG_H

#include <vdr/status.h>
#include "i18n.h"

class cPluginIEpg:public cPlugin
{
//  friend class cChannelData;    // for accessing private doc from thread 

private:
  // Add any member variables or functions you may need here.
  int freqRun;                  // in Seconds. 
  // defines how often this thread runs 
  // Use Macro FREQRUN

  time_t t_Start;
  char *sDir;
public:

    cPluginIEpg (void);
    virtual ~ cPluginIEpg ();
  virtual const char *Version (void);
  virtual const char *Description (void);
  virtual const char *CommandLineHelp (void);
  virtual bool ProcessArgs (int argc, char *argv[]);
  virtual bool Initialize (void);
  virtual bool Start (void);
  virtual void Stop (void);
  virtual void Housekeeping (void);
  virtual cString Active (void);
  virtual const char *MainMenuEntry(void);
  virtual cMenuSetupPage *SetupMenu(void);
  virtual cOsdObject *MainMenuAction (void);
  virtual bool HasSetupOptions(void){ return true; } 
  virtual bool SetupParse (const char *Name, const char *Value);
};

class cRecordingsStatusMonitor : public cStatus 
{
protected:
  virtual void Recording(const cDevice *Device, const char *Name, const char *FileName, bool On, int ChannelNumber);

const char *Version(void);
const char *Description(void);
};

class cStatusRecording : public cPlugin 
{
private:
  cRecordingsStatusMonitor *statusMonitor;
public:
  cStatusRecording();
  virtual ~cStatusRecording();

  virtual bool Start(void);
protected:
const char *Version(void);
const char *Description(void);
};

class cChannelSwitchStatusMonitor : public cStatus 
{
private:
  char *sDir;
public:
  cChannelSwitchStatusMonitor(void);
  virtual ~cChannelSwitchStatusMonitor();
protected:
  virtual void ChannelSwitch(const cDevice *Device, int ChannelNumber);

const char *Version(void);
const char *Description(void);
};

class cStatusChannelSwitch : public cPlugin 
{
private:
  cChannelSwitchStatusMonitor *statusMonitor;
  char *sDir;
public:
  cStatusChannelSwitch(void);
  virtual ~cStatusChannelSwitch();

  virtual bool Start(void);
protected:
const char *Version(void);
const char *Description(void);
};




#endif //__IEPG_H
