/*


DO NOT EDIT THIS FILE WITH CHAR SET UTF-8!!!! USE iso8859-15 INSTEAD. WILL DAMAGE THE ENTITY CONVERSION CONSTANTS!
DO NOT EDIT THIS FILE WITH CHAR SET UTF-8!!!! USE iso8859-15 INSTEAD. WILL DAMAGE THE ENTITY CONVERSION CONSTANTS!
DO NOT EDIT THIS FILE WITH CHAR SET UTF-8!!!! USE iso8859-15 INSTEAD. WILL DAMAGE THE ENTITY CONVERSION CONSTANTS!
DO NOT EDIT THIS FILE WITH CHAR SET UTF-8!!!! USE iso8859-15 INSTEAD. WILL DAMAGE THE ENTITY CONVERSION CONSTANTS!
DO NOT EDIT THIS FILE WITH CHAR SET UTF-8!!!! USE iso8859-15 INSTEAD. WILL DAMAGE THE ENTITY CONVERSION CONSTANTS!


*/
/*
*  C Implementation: itools.c
*
* Description:
*
*
* Author: RealQuick <realquick@doublequick.de>, (C) 2009
*
* Copyright: See COPYING file that comes with this distribution
*
*/

#include <stdlib.h>
#include <iconv.h>
#include "itools.h"

#include "i18n.h"

// --- Static -----------------------------------------------------------

#define ELEMENTS(x) (sizeof(x) / sizeof(x[0]))

struct conv_table
{
    const char *from;
    const char *to;
};

static struct conv_table pre_conv_table[] =
{
    // 'to' field must be smaller than 'from'
    {"&#<p>",   "\n"
    }
};

static struct conv_table post_conv_table[] =
{
    // 'to' field must be smaller than 'from'
    // workaround for converting strings loaded via tinyxml
    // entities are coded without leading "&"
    // for example "&auml;" -> "auml;"
    //
  {"&#228;",   ""},
  {"&auml;",   ""},
  {"&#196;",   ""},
  {"&Auml;",   ""},
  {"&#246;",   ""},
  {"&ouml;",   ""},
  {"&#214;",   ""},
  {"&Ouml;",   ""},
  {"&#229;",   ""},
  {"&uml;",   ""},
  {"&#197;",   ""},
  {"&uml;",   ""},
  {"&#220;",   ""},
  {"&Uuml;",   ""},
  {"&#252;",   ""},
  {"&uuml;",   ""},
  {"&#223;",   ""},
  {"&szlig;",  ""},
  {"&#234;",   ""},
  {"&#8211;",  "-"},
  {"&ndash;",  "-"},
  {"&#38;",    "&"},
  {"&amp;",    "&"},
  {"&#58;",    ":"},
  {"&#91;",    "["},
  {"&#93;",    "]"},
  {"&#40;",    "'"},
  {"&#41;",    "'"},
  {"&#039;",   "'"},
  {"&#180;",   "'"},
  {"&acute;",  "'"},
  {"&#8216;",  "'"},
  {"&#8217;",  "'"},
  {"&#231;",   ""},
  {"&ccedil;", ""},
  {"&#233;",   ""},
  {"&eacute;", ""},
  {"&#226;",   ""},
  {"&acirc;",  ""},
  {"&#8364;",  ""},
  {"&euro;",   ""},
  {"&quot;",   "\""},
  {"&#8220;",  "\""},
  {"&#8221;",  "\""},
  {"&#8222;",  "\""},
  {"&#160;",   " "},
  {"&nbsp;",   " "},
  {"&lt;",     "<"},
  {"&gt;",     ">"},
  {"&deg;",     ""},
};

static char *htmlcharconv(char *str, struct conv_table *conv, unsigned int elem)
{
    if (str && conv)
    {
        for (unsigned int i = 0; i < elem; ++i)
        {
            char *ptr = strstr(str, conv[i].from);
            while (ptr)
            {
                int of = ptr - str;
                int l  = strlen(str);
                int l1 = strlen(conv[i].from);
                int l2 = strlen(conv[i].to);
                if (l2 > l1)
                {
                    esyslog("iepg: htmlcharconv(): cannot reallocate string");
                    return str;
                }
                if (l2 != l1)
                    memmove(str + of + l2, str + of + l1, l - of - l1 + 1);
                strncpy(str + of, conv[i].to, l2);
                ptr = strstr(str, conv[i].from);
            }
        }
        return str;
    }
    return NULL;
}

// --- General functions ------------------------------------------------

int charsetconv(const char *buffer, int buf_len, const char *str, int str_len, const char *from, const char *to)
{
    if (to && from)
    {
        iconv_t ic = iconv_open(to, from);
        if (ic >= 0)
        {
            size_t inbytesleft = str_len;
            size_t outbytesleft = buf_len;
            char *out = (char*)buffer;
            int ret;
            if ((ret = iconv(ic, (char**)&str, &inbytesleft, &out, &outbytesleft)) >= 0)
            {
                iconv_close(ic);
                return buf_len - outbytesleft;
            }
            iconv_close(ic);
        }
    }
    else
        esyslog("iepg: charsetconv(): charset is not valid");
    return -1;
}

char *striphtml(char *str)
{
    if (str)
    {
        char *c, t = 0, *r;
        str = htmlcharconv(str, pre_conv_table, ELEMENTS(pre_conv_table));
        c = str;
        r = str;
        while (*str != '\0')
        {
            if (*str == '<')
                t++;
            else if (*str == '>')
                t--;
            else if (t < 1)
                *(c++) = *str;
            str++;
        }
        *c = '\0';
        return htmlcharconv(r, post_conv_table, ELEMENTS(post_conv_table));
    }
    return NULL;
}

void *myrealloc(void *ptr, size_t size)
{
    /* There might be a realloc() out there that doesn't like reallocing
       NULL pointers, so we take care of it here */
    if (ptr)
        return realloc(ptr, size);
    else
        return malloc(size);
}


// --- UTF-8 support ---------------------------------------------------------

static uint iSystemToUtf8[128] = { 0 };

int iUtf8CharLen(const char *s)
{
    if (ciCharSetConv::SystemCharacterTable())
        return 1;
#define MT(s, m, v) ((*(s) & (m)) == (v)) // Mask Test
    if (MT(s, 0xE0, 0xC0) && MT(s + 1, 0xC0, 0x80))
        return 2;
    if (MT(s, 0xF0, 0xE0) && MT(s + 1, 0xC0, 0x80) && MT(s + 2, 0xC0, 0x80))
        return 3;
    if (MT(s, 0xF8, 0xF0) && MT(s + 1, 0xC0, 0x80) && MT(s + 2, 0xC0, 0x80) && MT(s + 3, 0xC0, 0x80))
        return 4;
    return 1;
}

uint iUtf8CharGet(const char *s, int Length)
{
    if (ciCharSetConv::SystemCharacterTable())
        return (uchar)*s < 128 ? *s : iSystemToUtf8[(uchar)*s - 128];
    if (!Length)
        Length = iUtf8CharLen(s);
    switch (Length)
    {
    case 2:
        return ((*s & 0x1F) << 6) |  (*(s + 1) & 0x3F);
    case 3:
        return ((*s & 0x0F) << 4) | ((*(s + 1) & 0x3F) << 6) |  (*(s + 2) & 0x3F);
    case 4:
        return ((*s & 0x07) << 2) | ((*(s + 1) & 0x3F) << 4) | ((*(s + 2) & 0x3F) << 6) | (*(s + 3) & 0x3F);
    }
    return *s;
}

int iUtf8CharSet(uint c, char *s)
{
    if (c < 0x80 || ciCharSetConv::SystemCharacterTable())
    {
        if (s)
            *s = c;
        return 1;
    }
    if (c < 0x800)
    {
        if (s)
        {
            *s++ = ((c >> 6) & 0x1F) | 0xC0;
            *s   = (c & 0x3F) | 0x80;
        }
        return 2;
    }
    if (c < 0x10000)
    {
        if (s)
        {
            *s++ = ((c >> 12) & 0x0F) | 0xE0;
            *s++ = ((c >>  6) & 0x3F) | 0x80;
            *s   = (c & 0x3F) | 0x80;
        }
        return 3;
    }
    if (c < 0x110000)
    {
        if (s)
        {
            *s++ = ((c >> 18) & 0x07) | 0xF0;
            *s++ = ((c >> 12) & 0x3F) | 0x80;
            *s++ = ((c >>  6) & 0x3F) | 0x80;
            *s   = (c & 0x3F) | 0x80;
        }
        return 4;
    }
    return 0; // can't convert to UTF-8
}

int iUtf8SymChars(const char *s, int Symbols)
{
    if (ciCharSetConv::SystemCharacterTable())
        return Symbols;
    int n = 0;
    while (*s && Symbols--)
    {
        int sl = iUtf8CharLen(s);
        s += sl;
        n += sl;
    }
    return n;
}

int iUtf8StrLen(const char *s)
{
    if (ciCharSetConv::SystemCharacterTable())
        return strlen(s);
    int n = 0;
    while (*s)
    {
        s += iUtf8CharLen(s);
        n++;
    }
    return n;
}

char *iUtf8Strn0Cpy(char *Dest, const char *Src, int n)
{
    if (ciCharSetConv::SystemCharacterTable())
        return strn0cpy(Dest, Src, n);
    char *d = Dest;
    while (*Src)
    {
        int sl = iUtf8CharLen(Src);
        n -= sl;
        if (n > 0)
        {
            while (sl--)
                *d++ = *Src++;
        }
        else
            break;
    }
    *d = 0;
    return Dest;
}

int iUtf8ToArray(const char *s, uint *a, int Size)
{
    int n = 0;
    while (*s && --Size > 0)
    {
        if (ciCharSetConv::SystemCharacterTable())
            *a++ = (uchar)*s++;
        else
        {
            int sl = iUtf8CharLen(s);
            *a++ = iUtf8CharGet(s, sl);
            s += sl;
        }
        n++;
    }
    if (Size > 0)
        *a = 0;
    return n;
}

int iUtf8FromArray(const uint *a, char *s, int Size, int Max)
{
    int NumChars = 0;
    int NumSyms = 0;
    while (*a && NumChars < Size)
    {
        if (Max >= 0 && NumSyms++ >= Max)
            break;
        if (ciCharSetConv::SystemCharacterTable())
        {
            *s++ = *a++;
            NumChars++;
        }
        else
        {
            int sl = iUtf8CharSet(*a);
            if (NumChars + sl <= Size)
            {
                iUtf8CharSet(*a, s);
                a++;
                s += sl;
                NumChars += sl;
            }
            else
                break;
        }
    }
    if (NumChars < Size)
        *s = 0;
    return NumChars;
}

// --- cCharSetConv ----------------------------------------------------------

char *ciCharSetConv::systemCharacterTable = NULL;

ciCharSetConv::ciCharSetConv(const char *FromCode, const char *ToCode)
{
    if (!FromCode)
        FromCode = systemCharacterTable;
    if (!ToCode)
        ToCode = "UTF-8";
    cd = (FromCode && ToCode) ? iconv_open(ToCode, FromCode) : (iconv_t)-1;
    result = NULL;
    length = 0;
}

ciCharSetConv::~ciCharSetConv()
{
    free(result);
    iconv_close(cd);
}

void ciCharSetConv::SetSystemCharacterTable(const char *CharacterTable)
{
    free(systemCharacterTable);
    systemCharacterTable = NULL;
    if (!strcasestr(CharacterTable, "UTF-8"))
    {
        // Set up a map for the character values 128...255:
        char buf[129];
        for (int i = 0; i < 128; i++)
            buf[i] = i + 128;
        buf[128] = 0;
        ciCharSetConv csc(CharacterTable);
        const char *s = csc.Convert(buf);
        int i = 0;
        while (*s)
        {
            int sl = iUtf8CharLen(s);
            iSystemToUtf8[i] = iUtf8CharGet(s, sl);
            s += sl;
            i++;
        }
        systemCharacterTable = strdup(CharacterTable);
    }
}

const char *ciCharSetConv::Convert(const char *From, char *To, size_t ToLength)
{
    if (cd != (iconv_t)-1 && From && *From)
    {
        char *FromPtr = (char *)From;
        size_t FromLength = strlen(From);
        char *ToPtr = To;
        if (!ToPtr)
        {
            length = max(length, FromLength * 2); // some reserve to avoid later reallocations
            result = (char *)realloc(result, length);
            ToPtr = result;
            ToLength = length;
        }
        else if (!ToLength)
            return From; // can't convert into a zero sized buffer
        ToLength--; // save space for terminating 0
        char *Converted = ToPtr;
        while (FromLength > 0)
        {
            if (iconv(cd, &FromPtr, &FromLength, &ToPtr, &ToLength) == size_t(-1))
            {
                if (errno == E2BIG || (errno == EILSEQ && ToLength < 1))
                {
                    if (To)
                        break; // caller provided a fixed size buffer, but it was too small
                    // The result buffer is too small, so increase it:
                    size_t d = ToPtr - result;
                    size_t r = length / 2;
                    length += r;
                    result = (char *)realloc(result, length);
                    ToLength += r;
                    ToPtr = result + d;
                }
                if (errno == EILSEQ)
                {
                    // A character can't be converted, so mark it with '?' and proceed:
                    FromPtr++;
                    FromLength--;
                    *ToPtr++ = '?';
                    ToLength--;
                }
                else if (errno != E2BIG)
                    return From; // unknown error, return original string
            }
        }
        *ToPtr = 0;
        return Converted;
    }
    return From;
}

