//
// C++ Interface: misc.h
//
// Description: 
//
//
// Author: RealQuick <RealQuick@doubleQuick.de>, (C) 2009
//
// Copyright: See COPYING file that comes with this distribution
//
//

#ifndef __MISC_H_
#define __MISC_H_

#include <time.h>
#include <string>
#include <vdr/channels.h>       // for Channels

#include "xmlepg2vdrthread.h"

/******Misc functions ****************/

using namespace std;

char *get_xml_from_zip(char *path);
char *get_dir_per_day(char *path, int day);

int get_file_size(char *path);

void setup_utf8(string *str);

#define POLY 0xA001             // CRC16
unsigned int crc16 (unsigned int crc, unsigned char const *p, int len);


time_t str2time_t (const char *parmTime, const char *parmDate = NULL, int jumpDays = 0);
/*
 *   parmTime is "1130" not "11:30"
 *   parmDate is "dd/mm/yyyy" for eg. "17/11/2007"
 *
 */

time_t dtstr2time_t (const char *parmTime);
/*
 *   Date is "yyyy-mm-dd hh:mm:ss"
 *
 */

const char *get_genre(string genre_id);

bool file_exists(char *path);
bool SetChannelData(cProviderChannelList *ChannelList, const char *channelName, int *ProviderChannel, const char *ProviderChannelString, int nProvider);
void setup_utf8 ( string *str );

void touch_file(char *path, time_t now);
int Cleanup(const char *path, const char *ext, int nDaysBack = 0);

void do_log ( const char *path, const char *logfile, const char *buf, bool newfile = false );

bool ReadUrlList ( cThreadXmlEpg2vdr *p, std::vector < cURLFile > *Urls, const char *sConfigDir, int nProvider, cProviderChannelList *ChannelList, bool Download=true, int WorkingDay=0, bool *bLoop =NULL);

int knuth_hash(const unsigned char *str, int base);
int GetHashIndex(cProviderChannelList *ChannelList, const char *ProviderChannel); 

#endif
