//
// C++ Interface: setup.h
//
// Description: Class definitions fpr setup
//
//
// Author: RealQuick <RealQuick@doubleQuick.de>, (C) 2009
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef __IEPG_SETUP_H
#define __IEPG_SETUP_H

#include <vdr/menu.h>
#include <string>
#include <vector>

using namespace std;


class cProviderStatus
{
public:
    int ProviderType;
    string Name;
    int Enabled;
    char Pin[50];
    char baseurl[512];
    int downloadManually;         // not saved by SetupStore()

    int  updatetime;
    int  autoupdate;
    int  days;

    cProviderStatus ()
    {
        ProviderType = 0;
        strcpy(baseurl, "");
        Enabled = 0;
        downloadManually = 0;
        strcpy(Pin, "");
        updatetime = 0;
        autoupdate = 0;
        days = 7;
    }
};

struct ciepgSetup
{
    ciepgSetup(void);
//  bool SetupParse(const char *Name, const char *Value);

    int  useproxy;
    char httpproxy[256];
    int hour_to_start;		// when to start 0=After boot, 1-24 full hour
    time_t lastupdate;
    int Priority;
    int NoEPGWorkaround;

    int save_rec_pic;
    int convert_to_png;
    int convert_to_raw;
    int pics_only_primetime;

    std::vector < cProviderStatus > SetupProviders;

    std::string sImageDirectory;
    std::string sDataDirectory;
};

class ciepgMenuSetupPage : public cMenuSetupPage
{
private:
    char *starttimes[26];
    const char *prio[4];
    const char *noepg_mode[5];

    ciepgSetup m_NewSetup;
    void Setup();
protected:
    virtual void Store(void);

public:
    ciepgMenuSetupPage(void);
    virtual ~ciepgMenuSetupPage();

    virtual eOSState ProcessKey(eKeys Key);

//    virtual void Store(void);
};

#define BASE_URL_PROVIDERTYPE0  "http://www.bleb.org/tv/data/listings/%d"
#define BASE_URL_PROVIDERTYPE1 "http://www.epgdata.com/index.php?action=sendPackage&iLang=en&iOEM=&iCountry=&popup=0&pin=%s&dayOffset=%d"

#define STARTTIME_VALUES 25

extern ciepgSetup iepgSetup;

#endif
