/*
*  C interface: xmlepg2vdrthread
*
* Description:  A thread is created that runs in the background collecting
*               xml-EPG data from websites and loading it into vdr schedules
*
* Author: RealQuick <RealQuick@doubleQuick.de>, (C) 2009
*
* Copyright: See COPYING file that comes with this distribution
*
*/

#ifndef __XMLEPG2VDRTHREAD_H_
#define __XMLEPG2VDRTHREAD_H_

/*
 * A thread is created that runs in the background collecting
 * xml-EPG data from websites and loading it into vdr schedules
 */

#include <vdr/channels.h>       // for Channels

#include <string>

using namespace std;

/***************** URL FILE class********************/
class cURLFile
{

public:
    string ChannelName;
    string ChannelURL;
    string ChannelId;  // ID as used in xml document of provider
    string EpgFileName;           // seperate files for each channel
    int ProviderType;
    bool isError;
    cURLFile ()
    {
        isError = true;
    }

};                              // end class

class cProviderChannelList
{
public:
    tChannelID ChannelId;
    string sHashString;
    string ChannelName;
    int Provider;
};

/************** cThreadXmlEpg2vdr Class *************/
class cThreadXmlEpg2vdr : public cThread
{
private:
    bool bDownloadError;
    bool bWarnings;
    bool isAlreadyRunning;
    int WorkingDay;

    bool bQuiet;

    bool CleanEpgOnly;

    char *sConfigDir;
    bool forceEPG;		// force import of already imported data

    //TODO implement check of forcePIC in channeldata.c
    bool forcePIC;		// force conversion of already converted pictures

    /*        tChannelID *ChannelList; // array of vdr channel id (index would be provider channel id) */
    cProviderChannelList *ChannelList;

public:
    cThreadXmlEpg2vdr ( char *xConfigDir, bool xforceEPG = false, bool xforcePIC = false, bool xCleanEpgOnly = false, bool xQuiet = true);
    ~cThreadXmlEpg2vdr ();
    void killThread ( int sec );
    int downloadURL ( char *URL, char *filename );
    void Action ();

    void SetQuiet(bool xQuiet);

    bool isRunning()
    {
        return isAlreadyRunning;
    };
};

/***** END cThreadXmlEpg2vdr class *****************/

#endif
